/* Copyright 2010, Object Management Group, Inc.
 * Copyright 2010, PrismTech, Inc.
 * Copyright 2010, Real-Time Innovations, Inc.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.omg.dds.topic;

import org.omg.dds.core.policy.UserData;
import org.omg.dds.type.Extensibility;
import org.omg.dds.type.ID;
import org.omg.dds.type.Key;


@Extensibility(Extensibility.Kind.MUTABLE_EXTENSIBILITY)
public abstract class ParticipantBuiltinTopicData
{
    // -----------------------------------------------------------------------
    // Private Constants
    // -----------------------------------------------------------------------

    private static final long serialVersionUID = -1531303601733890381L;



    // -----------------------------------------------------------------------
    // Factory Methods
    // -----------------------------------------------------------------------

    /**
     * @param bootstrap Identifies the Service instance to which the new
     *                  object will belong.
     */
    /*
    public static ParticipantBuiltinTopicData newParticipantBuiltinTopicData(
            Bootstrap bootstrap) {
        return bootstrap.getSPI().newParticipantBuiltinTopicData();
    }
      */


    // -----------------------------------------------------------------------
    // Instance Methods
    // -----------------------------------------------------------------------

    @ID(0x0050) @Key
    public abstract BuiltinTopicKey getKey();

    @ID(0x002C)
    public abstract UserData getUserData();


    // --- From Object: ------------------------------------------------------

    @Override
    public abstract ParticipantBuiltinTopicData clone();
}
